swagger: "2.0"
info:
  title: Element API
  description: REST API to manage Element resources.
  version: 1.0.0
  contact:
    email: skf@bahay.dk
host: www.element.korfitz.com
basePath: /api
schemes:
  - https
securityDefinitions:
  Bearer:
    description: |
      In order to use this API, you need to authenticate yourself first.
      To do this, a JWT is required when calling any of the endpoints, which
      is obtained by calling this route first, given it an email and password :

          "/auth/fetch-token"

      Then it will give you a webtoken, that you need to submit in every api calls from hereon,
      with the following syntax set in the 'Authorization' header :

          Bearer xxxxxx.yyyyyyy.zzzzzz

    type: apiKey
    name: Authorization
    in: header
paths:
  /auth/fetch-token:
    post:
      tags:
        - Authenticate
      summary: Fetch auth token.
      description: Authenticate yourself in order to gain access to the rest of the API.
      consumes:
        - application/x-www-form-urlencoded
      parameters:
        - in: formData
          name: email
          type: string
          description: The email of the user to authenticated
        - in: formData
          name: password
          type: string
          description: User password
      produces:
        - application/json
      responses:
        200:
          description: OK
        401:
          description: Unauthorized

  /get/users:
    get:
      security:
        - Bearer: []
      tags:
        - Users
      summary: Get a list of ALL users
      description: ...
      consumes:
        - application/x-www-form-urlencoded
      produces:
        - application/json
      responses:
        200:
          description: OK
        401:
          description: Unauthorized

  /get/user/{id}:
    get:
      security:
        - Bearer: []
      tags:
        - Users
      summary: Get a particular user by it's ID
      description: ...
      consumes:
        - application/x-www-form-urlencoded
      parameters:
        - name: id
          in: path
          description: User ID
          type: integer
          required: true
      produces:
        - application/json
      responses:
        200:
          description: OK
        401:
          description: Unauthorized